#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>



#define INF (1<<29)

#define MAXN 256
#define MAXM 64


int g[MAXN][MAXN];
int line[2][MAXM][4];
int pt[MAXN][2];
int pinl[MAXN][MAXM];
int S, T;
int N, M;
int P;



int min(int a, int b)  {return (a<b)?a:b;}
int max(int a, int b)  {return (a>b)?a:b;}
void read_all(void);
void do_all(void);
int dist(int i1, int i2);
void dijkstra(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i, j;
  int lineco[MAXM][2];
  
  FILE *f = fopen("zad1.dat", "rt");
  fscanf(f, "%d", &M);
  for (j = 0; j < 2; j++) {
    for (i = 0; i < M+1; i++) {
      fscanf(f, "%d %d", &lineco[i][0], &lineco[i][1]);
    }
    for (i = 0; i < M; i++) {
      line[j][i][0] = lineco[i][0];
      line[j][i][1] = lineco[i][1];
      line[j][i][2] = lineco[i+1][0];
      line[j][i][3] = lineco[i+1][1];
    }
  }
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d %d", &pt[i][0], &pt[i][1]);
  }
  fclose(f);
}



void do_all(void)
{
  int i, j, k, hv, u, P1;
  int minx, maxx, miny, maxy;

  S = N;
  T = N+1;
  memset(g, 32, sizeof(g));
  for (i = 0; i < M; i++) {
    hv = 1;
    if (line[0][i][0] == line[0][i][2])  hv = 0;
    minx = maxx = line[0][i][0];
    miny = maxy = line[0][i][1];
    for (j = 0; j < 2; j++) {
      for (k = 0; k <= 2; k+=2) {
        if (line[j][i][k] < minx)  minx = line[j][i][k];
        if (line[j][i][k] > maxx)  maxx = line[j][i][k];
        if (line[j][i][k+1] < miny)  miny = line[j][i][k+1];
        if (line[j][i][k+1] > maxy)  maxy = line[j][i][k+1];
      }
    }
    if (hv == 0) {
      g[S][T] = min(g[S][T], maxx-minx);
    }
    else {
      g[S][T] = min(g[S][T], maxy-miny);
    }
    for (j = 0; j < N; j++) {
      int d = INF;
      
      if (pt[j][0] > maxx || pt[j][0] < minx)  continue;
      if (pt[j][1] > maxy || pt[j][1] < miny)  continue;
      pinl[j][i] = 1;
      for (k = 0; k < 2; k++) {
        if (hv == 0)  d = abs(pt[j][0]-line[k][i][0]);
        if (hv == 1)  d = abs(pt[j][1]-line[k][i][1]);
        u = N+2*i+k;
        g[u][j] = g[j][u] = min(g[u][j], d);
      }
    }
  }
  for (i = 0; i < N; i++) {
    for (j = i+1; j < N; j++) {
      for (k = 0; k < M; k++) {
        if (pinl[i][k] && pinl[j][k]) {
          int d = dist(i, j);
          g[i][j] = g[j][i] = min(g[i][j], d);
          break;
        }
      }
    }
  }
  P1 = INF;
  for (i = 0; i < M; i++) {
    S = N+2*i;
    T = N+2*i+1;
    N += 2*M;
    dijkstra();
    N -= 2*M;
    if (P < P1)  P1 = P;
  }
  P = P1;
}



int dist(int i1, int i2)
{
  int x, y;

  x = abs(pt[i1][0]-pt[i2][0]);
  y = abs(pt[i1][1]-pt[i2][1]);
  return max(x, y);
}



void dijkstra(void)
{
  int used[MAXN];
  int shortest[MAXN];
  int ish, sh;
  int i;

  memset(used, 0, sizeof(used));
  memset(shortest, 32, sizeof(shortest));
  shortest[S] = 0;
  for (;;) {
    sh = INF;
    ish = -1;
    for (i = 0; i < N; i++) {
      if (used[i])  continue;
      if (shortest[i] < sh)  sh = shortest[ish=i];
    }
    if (ish == -1 || ish == T)  break;
    used[ish] = 1;
    for (i = 0; i < N; i++) {
      int m = max(sh, g[ish][i]);
      if (used[i])  continue;
      if (m < shortest[i]) {
        shortest[i] = m;
      }
    }
  }
  P = shortest[T];
}



void write_all(void)
{
  FILE *f = fopen("zad1.res", "wt");
  fprintf(f, "%d\n", P);
  fclose(f);
}

