#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>



#define MAXN 1024



int g1[MAXN][MAXN];
int g[MAXN][MAXN];
int deg[MAXN][2];
int active[MAXN];
int used[MAXN];
int st[MAXN];
int ist;
int N, K;
int P;
int AA;



void read_all(void);
void do_all(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i, a, b;
  
  FILE *f = fopen("zad3.dat", "rt");
  fscanf(f, "%d %d", &N, &K);
  for (i = N*(N-1)/2-1; i >= 0; i--) {
    fscanf(f, "%d %d", &a, &b);  a--;  b--;
    g1[a][b] = 1;
    g[a][deg[a][0]++] = b;
    deg[b][1]++;
  }
  fclose(f);
}



void do_all(void)
{
  int i, j, nactive;

  clock();
  for (i = 0; i < N; i++)  active[i] = 1;
  nactive = N;
  for (;;) {
    int naf = 0;
    for (i = 0; i < N; i++) {
      if (active[i] == 0)  continue;
      if (deg[i][0] == 0 || deg[i][1] == 0) {
        active[i] = 0;
        nactive--;
        naf++;
        break;
      }
    }
    if (naf == 0)  break;
    if (nactive < K)  break;
    for (j = 0; j < N; j++) {
      if (g1[j][i] == 1)  deg[j][0]--;
      if (g1[i][j] == 1)  deg[j][1]--;
    }
  }
  memset(g, 0, sizeof(g));
  memset(deg, 0, sizeof(deg));
  for (i = 0; i < N; i++) {
    if (active[i] == 0)  continue;
    for (j = i+1; j < N; j++) {
      if (active[j] == 0)  continue;
      if (g1[i][j] == 1) {
        g[i][deg[i][0]++] = j;
        deg[j][1]++;
      }
      else {
        g[j][deg[j][0]++] = i;
        deg[i][1]++;
      }
    }
  }
  for (i = 0, nactive = 0; i < N; i++) {
    nactive += active[i];
    active[i]++;
    if (nactive < K)  continue;
    st[ist++] = i;
    for (j = 0; j < deg[i][0]; j++) {
      int res = DFS(g[i][j], i, K-1);
      if (res == 1)  P = 1;
      if (res != 0)  return;
    }
    st[--ist] = 0;
  }
}



int DFS(int u, int v, int k)
{
  int i, w, res;

  if (AA%32 == 0) {
    double x = 1.*clock()/CLOCKS_PER_SEC;
/*    printf("%d %.2lf\n", AA, x);*/
    if (x > 1.95) {
      return -1;
    }
  }
  if (u == v) {
    if (k == 0)  return 1;
    else  return 0;
  }
  used[u] = 1;
  st[ist++] = u;
  AA++;
  for (i = 0; i < deg[u][0]; i++) {
    w = g[u][i];
    if (active[w] != 2 || used[w])  continue;
    if (w != v && k-1 == 0)  continue;
    if (w == v && k-1 != 0)  continue;
    if (w == v && k-1 == 0)  return 1;
    res = DFS(w, v, k-1);
    if (res)  return res;
  }
  st[--ist] = 0;
  used[u] = 0;
  return 0;
}



void write_all(void)
{
  FILE *f = fopen("zad3.res", "wt");
  if (P == 0) {
    fprintf(f, "%d\n", P);
  }
  else {
    int i;
    for (i = 0; i < K; i++) {
      fprintf(f, "%d%s", 1+st[i], (i==K-1)?"\n":" ");
    }
  }
  fclose(f);
}

