#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>



#define MAXN 100100
#define EPS (1e-11)



int N;
double p[MAXN][4];
double p1[MAXN][4];
int st[MAXN];
int ist;
double P[3];



void read_all(void);
void do_all(void);
int cmp_pr(const void *a, const void *b);
int cmp_px(const void *a, const void *b);
int ORNi(double *p1, double *p2, double *p3);
double ORN(double *p1, double *p2, double *p3);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("zad4.dat", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%lf %lf", &p[i][0], &p[i][1]);
  }
  fclose(f);
}



void do_all(void)
{
  int i, i1, i2, i3;
  double x, y;
  double a1, b1, c1, a2, b2, c2;
  double x1, x2, x3, y1, y2, y3;
  double xx, yy, dd;

  qsort(p, N, sizeof(p[0]), cmp_px);

  st[ist++] = 0;
  for (i = 0; i < N; i++) {
    if (i != N-1 && ORNi(p[0], p[N-1], p[i]) <= 0)  continue;
    st[ist++] = i;
    while (ist-3 >= 0 && ORNi(p[st[ist-3]], p[st[ist-2]], p[st[ist-1]]) >= 0) {
      st[ist-2] = st[ist-1];
      ist--;
    }
  }
  for (i = N-2; i > 0; i--) {
    if (i != N-1 && ORNi(p[0], p[N-1], p[i]) >= 0)  continue;
    st[ist++] = i;
    while (ist-3 >= 0 && ORNi(p[st[ist-3]], p[st[ist-2]], p[st[ist-1]]) >= 0) {
      st[ist-2] = st[ist-1];
      ist--;
    }
  }
  for (i = 0; i < ist; i++) {
    p1[i][0] = p[st[i]][0];
    p1[i][1] = p[st[i]][1];
    p1[i][2] = p[st[i]][2];
  }

  N = ist;
  x = y = 0;
  for (i = 0; i < N; i++) {
    x += p1[i][0];
    y += p1[i][1];
  }
  x /= N;
  y /= N;
  for (i = 0; i < N; i++) {
    p1[i][2] = hypot(p1[i][0]-x, p1[i][0]-y);
  }
  qsort(p1, N, sizeof(p1[0]), cmp_pr);
  if (N > 100)  N = 100;

  P[2] = 1<<29;
  for (i1 = 0; i1 < N; i1++) {
    x1 = p1[i1][0];
    y1 = p1[i1][1];
    for (i2 = i1+1; i2 < N; i2++) {
      x2 = p1[i2][0];
      y2 = p1[i2][1];
      for (i3 = i2+1; i3 < N; i3++) {
        x3 = p1[i3][0];
        y3 = p1[i3][1];
        a1 = 2*(x2-x1);
        b1 = 2*(y2-y1);
        c1 = x1*x1+y1*y1-x2*x2-y2*y2;
        a2 = 2*(x3-x1);
        b2 = 2*(y3-y1);
        c2 = x1*x1+y1*y1-x3*x3-y3*y3;

        if (fabs(a1*b2-a2*b1) < EPS)  continue;
        xx = (c2*b1-c1*b2)/(a1*b2-a2*b1);
        yy = (c2*a1-c1*a2)/(b1*a2-b2*a1);
        dd = 0;
        for (i = 0; i < N; i++) {
          double ddd;
          ddd = hypot(xx-p[i][0], yy-p[i][1]);
          if (ddd > dd)  dd = ddd;
        }
        if (dd < P[2]) {
          P[0] = xx;
          P[1] = yy;
          P[2] = dd;
        }
      }
    }
  }
}



int ORNi(double *p1, double *p2, double *p3)
{
  double res = ORN(p1, p2, p3);
  if (res < -EPS)  return -1;
  if (res >  EPS)  return  1;
  return 0;
}



double ORN(double *p1, double *p2, double *p3)
{
  double res = 0;

  res =  p1[0]*p2[1]+p2[0]*p3[1]+p3[0]*p1[1];
  res -= p1[0]*p3[1]+p3[0]*p2[1]+p2[0]*p1[1];
  return res;
}



int cmp_pr(const void *a, const void *b)
{
  double res = ((double *)b)[2]-((double *)a)[2];
  if (res < -EPS)  return -1;
  if (res >  EPS)  return  1;
  return 0;
}



int cmp_px(const void *a, const void *b)
{
  double res = ((double *)a)[0]-((double *)b)[0];
  if (res < -EPS)  return -1;
  if (res >  EPS)  return  1;
  res = ((double *)a)[1]-((double *)b)[1];
  if (res < -EPS)  return -1;
  if (res >  EPS)  return  1;
  return 0;
}



void write_all(void)
{
  FILE *f = fopen("zad4.res", "wt");
  fprintf(f, "%.2lf\n%.2lf %.2lf\n", P[0], P[1], P[2]);
  fclose(f);
}

