{$MODE objfpc}

Const
  timelimit = 16;

Type
  TSmPoint = Record
    X, Y : SmallInt;
  End;
  TPoint = Record
    X, Y : Integer;
  End;

Var
  N, M : Integer;
  UWl : Array[0..31] Of TPoint;
  DWl : Array[0..31] Of TPoint;
  Pnt : Array[0..123] Of TPoint;
  Queue : Array[0..4000000] Of TSmPoint;
  StartX1, StartY1, StartX2, StartY2 : Integer;
  EndX1, EndY1, EndX2, EndY2 : Integer;
  QStart, QEnd : Integer;
  DestReached : Boolean;
  starttime : Word;
  scalefactor : Integer;
  fixX, fixY : Integer;
  XNum, YNum : Integer;
  Xs, Ys : Array[0..1000] Of Integer;

Procedure FX(Var X : Integer);

Begin
{  If ((X + fixX) Mod scalefactor) <> 0 Then
    Writeln('bg');}
  X := (X + fixX) Div scalefactor;
End;

Procedure FY(Var Y : Integer);

Begin
{  If ((Y + fixY) Mod scalefactor) <> 0 Then
    Writeln('bg');}
  Y := (Y + fixY) Div scalefactor;
End;

Procedure WriteOut(Q : Integer);

Var
  F : Text;

Begin
{  Writeln('res', Q*scalefactor, ' scalefactor', scalefactor);}

  ASSign(F, 'ZAD1.RES');
  Rewrite(F);
  Writeln(F, Q * scalefactor);
  Close(F);

  Halt;
End;

Procedure Sort(Var Q1, Q2 : Integer);

Var
  tmp : Integer;

Begin
  If Q1 > Q2 Then
  Begin
    tmp := Q1;
    Q1 := Q2;
    Q2 := tmp;
  End;
{  Writeln(Q1, ' ', Q2, 's');}
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;

Begin
  ASSign(F, 'ZAD1.DAT');
  Reset(F);
  Readln(F, M);
  For I := 1 To M + 1 Do
    Readln(F, UWl[I].X, UWl[I].Y);
  For I := 2 To M + 2 Do
    Readln(F, DWl[I].X, DWl[I].Y);
  StartX2 := UWl[1].X;
  StartY2 := UWl[1].Y;
  StartX1 := DWl[2].X;
  StartY1 := DWl[2].Y;
  EndX2 := UWl[M + 1].X;
  EndY2 := UWl[M + 1].Y;
  EndX1 := DWl[M + 2].X;
  EndY1 := DWl[M + 2].Y;
  UWl[M + 2].X := DWl[M + 2].X;
  UWl[M + 2].Y := DWl[M + 2].Y;
  DWl[1].X := UWl[1].X;
  DWl[1].Y := UWl[1].Y;
  Readln(F, N);
  For I := 1 To N Do
    Readln(F, Pnt[I].X, Pnt[I].Y);
  Close(F);
End;

Function HEdge(Y, X1, X2 : Integer) : Boolean;

Var
  I : Integer;
  LX1, LY1, LX2, LY2 : Integer;

Begin
  HEdge := True;
  Sort(X1, X2);
  If (X2 - X1) <> 1 Then
    Exit(False);
  For I := 1 To M + 1 Do
  Begin
    LX1 := UWl[I].X;
    LY1 := UWl[I].Y;
    LX2 := UWl[I + 1].X;
    LY2 := UWl[I + 1].Y;
    If LX1 = LX2 Then
    Begin
      If LX1 <> X2 Then
        Continue;
      Sort(LY1, LY2);
      If (LY1 <= Y) And (LY2 > Y) Then
        Exit(False);
    End;
  End;
  For I := 1 To M + 1 Do
  Begin
    LX1 := DWl[I].X;
    LY1 := DWl[I].Y;
    LX2 := DWl[I + 1].X;
    LY2 := DWl[I + 1].Y;
    If LX1 = LX2 Then
    Begin
      If LX1 <> X2 Then
        Continue;
      Sort(LY1, LY2);
      If (LY1 <= Y) And (LY2 > Y) Then
        Exit(False);
    End;
  End;
End;

Function VEdge(X, Y1, Y2 : Integer) : Boolean;

Var
  I : Integer;
  LX1, LY1, LX2, LY2 : Integer;

Begin
  VEdge := True;
  Sort(Y1, Y2);
  If (Y2 - Y1) <> 1 Then
    Exit(False);
  For I := 1 To M + 1 Do
  Begin
    LX1 := UWl[I].X;
    LY1 := UWl[I].Y;
    LX2 := UWl[I + 1].X;
    LY2 := UWl[I + 1].Y;
    If LY1 = LY2 Then
    Begin
      If LY1 <> Y2 Then
        Continue;
      Sort(LX1, LX2);
      If (LX1 <= X) And (LX2 > X) Then
        Exit(False);
    End;
  End;
  For I := 1 To M + 1 Do
  Begin
    LX1 := DWl[I].X;
    LY1 := DWl[I].Y;
    LX2 := DWl[I + 1].X;
    LY2 := DWl[I + 1].Y;
    If LY1 = LY2 Then
    Begin
      If LY1 <> Y2 Then
        Continue;
      Sort(LX1, LX2);
      If (LX1 <= X) And (LX2 > X) Then
        Exit(False);
    End;
  End;
End;

Function Edge(X1, Y1, X2, Y2 : Integer) : Boolean;

Begin
  If X1 = X2 Then
    Edge := VEdge(X1, Y1, Y2)
  Else
    If Y1 = Y2 Then
      Edge := HEdge(Y1, X1, X2)
    Else
      Edge := False;
End;

Function MSz(X, Y : Integer) : Integer;

Var
  min, newm : Integer;
  xdiff, ydiff : Integer;
  I : Integer;
  LX1, LY1, LX2, LY2 : Integer;

Begin
  min := $7FFFFFFF;
  For I := 1 To N Do
    If (Pnt[I].X > X) And (Pnt[I].Y > Y) Then
    Begin
      xdiff := Pnt[I].X - X;
      ydiff := Pnt[I].Y - Y;
      If xdiff > ydiff Then
        newm := xdiff
      Else
        newm := ydiff;
      If newm < min Then
        min := newm;
    End;
  For I := 1 To M + 1 Do
  Begin
    LX1 := UWl[I].X;
    LY1 := UWl[I].Y;
    LX2 := UWl[I + 1].X;
    LY2 := UWl[I + 1].Y;
    If LY1 = LY2 Then
    Begin {hline}
      If LY1 <= Y Then
        Continue;
      Sort(LX1, LX2);
      If LX2 <= X Then
        Continue;
      If LX1 <= X Then
      Begin
        newm := LY1 - Y;
        If newm < min Then
          min := newm;
      End
      Else
      Begin
        xdiff := LX1 - X;
        ydiff := LY1 - Y;
        If xdiff > ydiff Then
          newm := xdiff
        Else
          newm := ydiff;
        If newm < min Then
          min := newm;
      End;
    End
    Else
    Begin {vline}
      If LX1 <= X Then
        Continue;
      Sort(LY1, LY2);
      If LY2 <= Y Then
        Continue;
      If LY1 <= Y Then
      Begin
        newm := LX1 - X;
        If newm < min Then
          min := newm;
      End
      Else
      Begin
        xdiff := LX1 - X;
        ydiff := LY1 - Y;
        If xdiff > ydiff Then
          newm := xdiff
        Else
          newm := ydiff;
        If newm < min Then
          min := newm;
      End;
    End;
  End;
  For I := 1 To M + 1 Do {222}
  Begin
    LX1 := DWl[I].X;
    LY1 := DWl[I].Y;
    LX2 := DWl[I + 1].X;
    LY2 := DWl[I + 1].Y;
    If LY1 = LY2 Then
    Begin {hline}
      If LY1 <= Y Then
        Continue;
      Sort(LX1, LX2);
      If LX2 <= X Then
        Continue;
      If LX1 <= X Then
      Begin
        newm := LY1 - Y;
        If newm < min Then
          min := newm;
      End
      Else
      Begin
        xdiff := LX1 - X;
        ydiff := LY1 - Y;
        If xdiff > ydiff Then
          newm := xdiff
        Else
          newm := ydiff;
        If newm < min Then
          min := newm;
      End;
    End
    Else
    Begin {vline}
      If LX1 <= X Then
        Continue;
      Sort(LY1, LY2);
      If LY2 <= Y Then
        Continue;
      If LY1 <= Y Then
      Begin
        newm := LX1 - X;
        If newm < min Then
          min := newm;
      End
      Else
      Begin
        xdiff := LX1 - X;
        ydiff := LY1 - Y;
        If xdiff > ydiff Then
          newm := xdiff
        Else
          newm := ydiff;
        If newm < min Then
          min := newm;
      End;
    End;
  End;
  MSz := min;
End;

Procedure NQ(X, Y : Integer);

Var
  X1, Y1, X2, Y2 : Integer;
  EX1, EY1, EX2, EY2 : Integer;
  sz : Integer;

Begin
  {check DestReached}
  X1 := X;
  Y1 := Y;
  sz := MSz(X, Y);
  X2 := X1 + sz;
  Y2 := Y1 + sz;
  EX1 := EndX1;
  EY1 := EndY1;
  EX2 := EndX2;
  EY2 := EndY2;
  If EX1 = EX2 Then
  Begin {}
    Sort(EY1, EY2);
    If (EX1 = X1) Or (EX1 = X2) Then
    Begin
      If (EY1 > Y2) Or (EY2 < Y1) Then
      Else
        DestReached := True;
    End;
  End
  Else
  Begin
    Sort(EX1, EX2);
    If (EY1 = Y1) Or (EY1 = Y2) Then
    Begin
      If (EX1 > X2) Or (EX2 < X1) Then
      Else
        DestReached := True;
    End;
  End;
  If DestReached Then
    Exit;

  {markvis}
{  Writeln(X, ' ', Y);}
  Inc(QEnd);
  Queue[QEnd].X := X;
  Queue[QEnd].Y := Y;
End;

Procedure DeQ(Var X, Y : Integer);

Begin
  X := Queue[QStart].X;
  Y := Queue[QStart].Y;
  Inc(QStart);
End;

Function Vis(X, Y : Integer) : Boolean;

Var
  I : Integer;

Begin
  For I := 0 To QEnd Do
  Begin
    If I > 5000 Then
      Exit(False);
    If (Queue[I].X = X) And (Queue[I].Y = Y) Then
      Exit(True);
  End;
  Vis := False;
End;

Function Bahur(lim : Integer) : Boolean;

Var
  I : Integer;
  tmp : Integer;
  X, Y : Integer;

Begin
  DestReached := False;
  QStart := 0;
  QEnd := -1;
  For I := StartY1 To StartY2 - 1 Do
  Begin
    tmp := MSz(StartX1, I);
    If tmp >= lim Then
      NQ(StartX1, I);
  End;
  While QStart <= QEnd Do
  Begin
    DeQ(X, Y);
    If (Edge(X, Y, X + 1, Y)) And (Not Vis(X + 1, Y)) Then
    Begin
      tmp := MSz(X + 1, Y);
      If tmp >= lim Then
        NQ(X + 1, Y);
    End;
    If DestReached Then
      Break;
    If (Edge(X, Y, X - 1, Y)) And (Not Vis(X - 1, Y)) Then
    Begin
      tmp := MSz(X - 1, Y);
      If tmp >= lim Then
        NQ(X - 1, Y);
    End;
    If DestReached Then
      Break;
    If (Edge(X, Y, X, Y + 1)) And (Not Vis(X, Y + 1)) Then
    Begin
      tmp := MSz(X, Y + 1);
      If tmp >= lim Then
        NQ(X, Y + 1);
    End;
    If DestReached Then
      Break;
    If (Edge(X, Y, X, Y - 1)) And (Not Vis(X, Y - 1)) Then
    Begin
      tmp := MSz(X, Y - 1);
      If tmp >= lim Then
        NQ(X, Y - 1);
    End;
    If (Word(Word(MemW[$46C]) - Word(starttime))) > Word(timelimit) Then
      DestReached := True;
    If DestReached Then
      Break;
  End;
  Bahur := DestReached;
End;

Procedure Bahur;

Var
  I : Integer;
  tmp : Boolean;

Begin
  For I := (Abs(StartY1 - StartY2) + 1) DownTo 2 Do
  Begin
{    Writeln('bhr', I);}
    tmp := Bahur(I);
    If tmp = True Then
      WriteOut(I);
  End;
  WriteOut(1);
End;

Procedure CalcScalefactor;

Var
  I, J : Integer;
  mindist, dist : Integer;
  isok : Boolean;

Function TryScalefactor(mindist : Integer) : Boolean;

Var
  dist : Integer;
  isok : Boolean;
  I : Integer;

Begin
  isok := True;
  For I := 1 To XNum - 1 Do
  Begin
    dist := Xs[I + 1] - Xs[I];
    If (dist Mod mindist) <> 0 Then
    Begin
      isok := False;
      Break;
    End;
  End;
  For I := 1 To YNum - 1 Do
  Begin
    dist := Ys[I + 1] - Ys[I];
    If (dist Mod mindist) <> 0 Then
    Begin
      isok := False;
      Break;
    End;
  End;
  If isok Then
  Begin
    scalefactor := mindist;
    fixX := -Xs[1];
    fixY := -Ys[1];
    FX(StartX1);
    FX(StartX2);
    FX(EndX1);
    FX(EndX2);
    FY(StartY1);
    FY(StartY2);
    FY(EndY1);
    FY(EndY2);
    For I := 1 To N Do
    Begin
      FX(Pnt[I].X);
      FY(Pnt[I].Y);
    End;
    For I := 1 To M + 2 Do
    Begin
      FX(UWl[I].X);
      FX(DWl[I].X);
      FY(UWl[I].Y);
      FY(DWl[I].Y);
    End;
  End;
  TryScalefactor := IsOk;
End;

Begin
  scalefactor := 1;
  XNum := 4;
  Xs[1] := StartX1;
  Xs[2] := StartX2;
  Xs[3] := EndX1;
  Xs[4] := EndX2;
  YNum := 4;
  Ys[1] := StartY1;
  Ys[2] := StartY2;
  Ys[3] := EndY1;
  Ys[4] := EndY2;
  For I := 1 To N Do
  Begin
    Inc(XNum);
    Xs[XNum] := Pnt[I].X;
    Inc(YNum);
    Ys[YNum] := Pnt[I].Y;
  End;
{  For I := 1 To XNum Do
    WRiteln(Xs[I]);}
  For I := 1 To M + 2 Do
  Begin
    Inc(XNum);
    Xs[XNum] := UWl[I].X;
    Inc(XNum);
    Xs[XNum] := DWl[I].X;
    Inc(YNum);
    Ys[YNum] := UWl[I].Y;
    Inc(YNum);
    Ys[YNum] := DWl[I].Y;
  End;
{  For I := 1 To XNum Do
    WRiteln(Xs[I]);}
  For I := 1 To XNum - 1 Do
    For J := I + 1 To XNum Do
      Sort(Xs[I], Xs[J]);
  For I := 1 To YNum - 1 Do
    For J := I + 1 To YNum Do
      Sort(Ys[I], Ys[J]);
  mindist := $7FFFFFFF;
  For I := 1 To XNum - 1 Do
  Begin
    dist := Xs[I + 1] - Xs[I];
    If dist <> 0 Then
    Begin
      If dist < mindist Then
        mindist := dist;
    End;
  End;
  For I := 1 To YNum - 1 Do
  Begin
    dist := Ys[I + 1] - Ys[I];
    If dist <> 0 Then
    Begin
      If dist < mindist Then
        mindist := dist;
    End;
  End;
  If Not TryScalefactor(mindist) Then
    If Not TryScalefactor(mindist Div 2) Then
      If Not TryScalefactor(mindist Div 3) Then
        If Not TryScalefactor(mindist Div 5) Then
          If Not TryScalefactor(mindist Div 4) Then
            TryScaleFactor(5);
End;

Begin
  ReadIn;
  starttime := MemW[$46C];
  CalcScalefactor;
  Bahur;
End.
