{$MODE objfpc}

Uses
  SysUtils;

Type
  Float = Extended;
  TPoint = Record
    X, Y : Float;
  End;

Var
  N : Integer;
  OrigPoint : Array[0..100006] Of TPoint;
  V : Array[0..100006] Of Boolean;
  Point : Array[0..100006] Of TPoint;
  OPN : Array[0..100006] Of Integer;
  PNum : Integer;

Operator < (a, b : TPoint) res : Boolean;

Begin
  If a.X < b.X Then
    res := True
  Else
    If a.X > b.X Then
      res := False
    Else
      res := a.Y < b.Y;
End;

Function dist(X1, Y1, X2, Y2 : Float) : Float;

Begin
  dist := Sqrt(Sqr(X2 - X1) + Sqr(Y2 - Y1));
End;

Procedure sort(l,r: longint);

Var
  i,j : longint;
  X, Y : TPoint;

Begin
  i := l;
  j := r;
  x := OrigPoint[(l+r) div 2];
  repeat
    while OrigPoint[i]<x do
      inc(i);
    while x<OrigPoint[j] do
      dec(j);
    if not(i>j) then
    begin
      y:=OrigPoint[i];
      OrigPoint[i]:=OrigPoint[j];
      OrigPoint[j]:=y;
      inc(i);
      j:=j-1;
    end;
  until i>j;
  if l<j then
    sort(l,j);
  if i<r then
    sort(i,r);
End;

Procedure QSort;

Begin
  Sort(1, N);
End;

Function Dir(X1, Y1, X2, Y2, X3, Y3 : Float) : Float;

Begin
  Dir := (Y2 - Y3) * (X2 - X1) + (Y2 - Y1) * (X3 - X2);
End;

Function Dir(Const p1, p2, p3 : TPoint) : Float;

Begin
  Dir := Dir(p1.X, p1.Y, p2.X, p2.Y, p3.X, p3.Y);
End;

Function tp(X1, Y1, X2, Y2, X3, Y3 : Float) : Boolean;

Var
{  dr : Float;}
  dp : Float;

Begin
{  dr := dir(X1, Y1, X2, Y2, X3, Y3);}
  dp := (X2 - X1) * (X3 - X2) + (Y2 - Y1) * (Y3 - Y2); {1->2  * 2->3}
  tp := dp >= 0;
End;

Function sine(X1, Y1, X2, Y2, X3, Y3 : Float) : Float;

Begin
  sine := Abs(Dir(X1, Y1, X2, Y2, X3, Y3)) /
          (Sqrt((Sqr(X2 - X1) + Sqr(Y2 - Y1))) * Sqrt((Sqr(X3 - X2) + Sqr(Y3 - Y2))));
End;

Function radius(X1, Y1, X2, Y2, X3, Y3 : Float) : Float;

Begin
  radius := Sqrt(Sqr(X1 - X3) + Sqr(Y1 - Y3)) / sine(X1, Y1, X2, Y2, X3, Y3);
  radius /= 2;
End;

Procedure Check(cx, cy, R : Float);

Var
  I : Integer;
  d : Float;

Begin
{  For I := 1 To N Do
  Begin
    d := Sqrt(Sqr(cx - OrigPoint[I].X) + Sqr(cy - OrigPoint[I].Y));
    If d > R Then
      Writeln('bug:', (d - R):0:50);
  End;}
End;

Procedure WriteOut_real(cx, cy, R : Float);

Var
  F : Text;

Begin
  ASSign(F, 'ZAD4.RES');
  Rewrite(F);
{  Check(cx, cy, R);}
  Writeln(F, R:0:2);
  Writeln(F, cx:0:2, ' ', cy:0:2);
  Close(F);
  Halt;
End;

Procedure WriteOut(p1, p2 : Integer);

Var
  X1, Y1, X2, Y2 : Float;

Begin
  X1 := Point[p1].X;
  Y1 := Point[p1].Y;
  X2 := Point[p2].X;
  Y2 := Point[p2].Y;
  WriteOut_real((X1 + X2)/2, (Y1 + Y2)/2, Sqrt(Sqr(X2 - X1) + Sqr(Y2 - Y1)) / 2);
End;

Procedure WriteOut(p1, p2, p3 : Integer);

Var
  X1, Y1, X2, Y2, X3, Y3 : Float;
  p, q : Float;
  QAX, QAY, QBX, QBY, AX, AY, BX, BY : Float;
  cx, cy : Float;
  cx2, cy2 : Float;

Begin
{  Writeln('tri');}
  X1 := Point[p1].X;
  Y1 := Point[p1].Y;
  X2 := Point[p2].X;
  Y2 := Point[p2].Y;
  X3 := Point[p3].X;
  Y3 := Point[p3].Y;

{  Y3 := Y2;} {debugtgggg}

  QAX := (X1 + X2) / 2; {1->2}
  QAY := (Y1 + Y2) / 2; {1->2}
  QBX := (X2 + X3) / 2; {2->3}
  QBY := (Y2 + Y3) / 2; {2->3}
  AX := Y2 - Y1; {1->2}
  AY := X1 - X2; {1->2}
  BX := Y3 - Y2; {2->3}
  BY := X2 - X3; {2->3}

  If BX = 0 Then
  Begin
    p := (QBX - QAX) / AX;

    cx := QAX + p*AX;
    cy := QAY + p*AY;
  End
  Else
  Begin

    p := (QBY - QAY + ((BY * (QAX - QBX)) / BX)) /
         (AY - ((AX * BY) / BX));
  {  q := (QAX - QBX + p*AX) / BX;}

    cx := QAX + p*AX;
    cy := QAY + p*AY;

  {  cx2 := QBX + q*BX;
    cy2 := QBY + q*BY;}
  End;

{  Writeln(dist(cx, cy, X1, Y1):0:50);
  Writeln(dist(cx, cy, X2, Y2):0:50);
  Writeln(dist(cx, cy, X3, Y3):0:50);
  Halt;}

  WriteOut_real(cx, cy, radius(X1, Y1, X2, Y2, X3, Y3));

(*  Writeln('res:');
  Writeln(X1:0:50, ' ', Y1:0:50);
  Writeln(X2:0:50, ' ', Y2:0:50);
  Writeln(X3:0:50, ' ', Y3:0:50);
  Writeln(radius(X1, Y1, X2, Y2, X3, Y3):0:50); {}
  Writeln(radius(X3, Y3, X2, Y2, X1, Y1):0:50); {}
  Writeln(radius(X2, Y2, X1, Y1, X3, Y3):0:50); {}
  Writeln(radius(X3, Y3, X1, Y1, X2, Y2):0:50); {}
  Writeln(radius(X1, Y1, X3, Y3, X2, Y2):0:50);
  Writeln(radius(X2, Y2, X3, Y3, X1, Y1):0:50);*)
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;

Begin
  ASSign(F, 'ZAD4.DAT');
  Reset(F);
  Readln(F, N);
  For I := 1 To N Do
    Readln(F, OrigPoint[I].X, OrigPoint[I].Y);
  Close(F);
End;

Procedure GenRandom;

Var
  I : Integer;

Begin
  N := 100000;
  For I := 1 To N Do
  Begin
    OrigPoint[I].X := Random(1000000)/100;
    OrigPoint[I].Y := Random(1000000)/100;
  End;
End;

Procedure CH;

Var
  I : Integer;

Begin {todo: handle all points on a single line}
  Point[1] := OrigPoint[1];
  Point[2] := OrigPoint[2];
  OPN[1] := 1;
  OPN[2] := 2;
  V[1] := True;
  V[2] := True;
  PNum := 0;
  For I := 1 To N Do
  Begin
    Inc(PNum);
    Point[PNum] := OrigPoint[I];
    OPN[PNum] := I;
    V[I] := True;
    While (PNum > 2) And (Dir(Point[PNum - 2], Point[PNum - 1], Point[PNum]) <= 0) Do
    Begin
      Dec(PNum);
      V[OPN[PNum]] := False;
{      V[PNum] := False;}
      Point[PNum] := Point[PNum + 1];
      OPN[PNum] := OPN[PNum + 1];
    End;
  End;

{  For I := 1 To PNum Do
  Begin
    Writeln(Point[I].X:0:50, ' ', Point[I].Y:0:50, ' ', OPN[I]);
  End;
  For I := 1 To N Do
    Writeln(V[I]);
  Writeln;}

  V[1] := False;

  For I := N - 1 DownTo 1 Do
  Begin
    If V[I] Then
      Continue;
    Inc(PNum);
    Point[PNum] := OrigPoint[I];
{    V[PNum] := True;}
    While (PNum > 2) And (Dir(Point[PNum - 2], Point[PNum - 1], Point[PNum]) <= 0) Do
    Begin
      Dec(PNum);
{      V[PNum] := False;}
      Point[PNum] := Point[PNum + 1];
    End;
  End;
{  For I := 1 To PNum Do
    Writeln(Point[I].X:0:50, ' ', Point[I].Y:0:50);
  Writeln;}
End;

Procedure Bahur;

Var
  I : Integer;
  base1, base2 : Integer;
  maxR, newR : Float;
  nextBase : Integer;
  alltp : Boolean;

Begin
  QSort;
  CH;

  base1 := 1;
  base2 := PNum - 1;
  Repeat
{    Writeln('b:', base1, ' ', base2);}
    maxR := 0;
    alltp := True;
    For I := base1 + 1 To base2 - 1 Do
    Begin
      If Not tp(Point[base1].X, Point[base1].Y,
                Point[I].X, Point[I].Y,
                Point[base2].X, Point[base2].Y) Then
      Begin
        alltp := False;
        newR := radius(Point[base1].X, Point[base1].Y,
                       Point[base2].X, Point[base2].Y,
                       Point[I].X, Point[I].Y);
        If newR > maxR Then
        Begin
          maxR := newR;
          nextBase := I;
        End;
      End;
    End;

    If alltp Then
    Begin
      WriteOut(base1, base2);
      Halt;
    End;

    If tp(Point[base1].X, Point[base1].Y,
          Point[base2].X, Point[base2].Y,
          Point[nextBase].X, Point[nextBase].Y) Then
    Begin
      base2 := nextBase;
    End
    Else
      If tp(Point[base2].X, Point[base2].Y,
            Point[base1].X, Point[base1].Y,
            Point[nextBase].X, Point[nextBase].Y) Then
      Begin
        base1 := nextBase;
      End
      Else
      Begin
        WriteOut(base1, base2, nextBase);
{        Writeln('betw', base1, ' ', base2, ' ', nextBase);}
        Halt;
      End;

{    Writeln(alltp, 'at');}

{    Writeln(Point[nextBase].X:0:50, ' ', Point[nextBase].Y:0:50);}

{    Halt;}
  Until False;
End;

Begin
  ReadIn;
{  Randomize;
  GenRandom;}
  Bahur;
End.
