#include <stdio.h>
#include <math.h>

typedef struct {
  double ang;
  double bx;
  double by;
  double no;
} pt;

FILE *fn;
int n, convs;
int conv[110000];
pt point[110000];
double x[110000];
double y[110000];
double ans, ansx, ansy;
double anstype;

double angle(double x1, double y1, double x2, double y2, double x3, double y3) {
  double a2=(x1-x3)*(x1-x3)+(y1-y3)*(y1-y3);
  double b2=(x2-x3)*(x2-x3)+(y2-y3)*(y2-y3);
  double c2=(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
  return (a2+b2-c2)/sqrt(4*a2*b2);
}

double orient(double x1, double y1, double x2, double y2, double x3, double y3) {
  return x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2);
}

int cmp(pt *a, pt *b) {
  if (a->ang<b->ang) return -1;
  else if (a->ang>b->ang) return 1;
  else if (a->bx<b->bx) return -1;
  else if (a->bx>b->bx) return 1;
  else if (a->by>b->by) return -1;
  else if (a->by<b->by) return 1;
  else return 0;
}

int main(void) {
int i, j, top=0, p1, p2, p3;
double t1, t2, t3, t4;
double x1, y1, x2, y2, a1, a2;

point[0].bx=1000000;
point[0].by=1000000;
fn=fopen("ZAD4.DAT", "r");
fscanf(fn, "%d", &n);
for (i=1; i<=n; i++) {
  fscanf(fn, "%lf %lf", &point[i].bx, &point[i].by);
  if (point[i].bx<point[top].bx || (point[i].bx==point[top].bx && point[i].by<point[top].by)) top=i;
}
fclose(fn);
for (i=1; i<=n; i++) {
  if (point[i].bx==point[top].bx && point[i].by==point[top].by) {
    point[i].ang=-10;
  } else {
    point[i].ang=atan2(point[i].by-point[top].by, point[i].bx-point[top].bx);
  }
}
qsort(&point[1], n, sizeof(pt), cmp);
conv[0]=1;
convs=1;
for (i=2; i<=n; i++) if (point[i].bx!=point[i-1].bx || point[i].by!=point[i-1].by) {
  for (j=convs-1; j>0; j--)
    if (orient(point[i].bx, point[i].by, point[conv[j]].bx, point[conv[j]].by, point[conv[j-1]].bx, point[conv[j-1]].by)<=-0.00001) break;
  j++;
  conv[j]=i;
  convs=j+1;
}
for (j=convs-1; j>1; j--)
  if (orient(point[i].bx, point[i].by, point[conv[j]].bx, point[conv[j]].by, point[conv[j-1]].bx, point[conv[j-1]].by)<=0.00001) break;
j++;
convs=j;
conv[convs]=conv[0];
for (i=0; i<=convs; i++) {
  x[i]=point[conv[i]].bx;
  y[i]=point[conv[i]].by;
}

p1=0;
p2=1;
while (1) {
  t1=-1;
  p3=-1;
  for (i=0; i<convs; i++) if (i!=p1 && i!=p2) {
    t3=angle(x[p1], y[p1], x[p2], y[p2], x[i], y[i]);
    if (t3>t1) {
      t1=t3;
      p3=i;
    }
  }
  if (t1>0) {
    if (angle(x[p1], y[p1], x[p3], y[p3], x[p2], y[p2])<0) {
      p2=p3;
    } else if (angle(x[p2], y[p2], x[p3], y[p3], x[p1], y[p1])<0) {
      p1=p3;
    } else {
      anstype=1;
      x1=(x[p1]+x[p2])/2;
      y1=(y[p1]+y[p2])/2;
      if (y[p1]==y[p2]) a1=1000000;
      else if (x[p1]==x[p2]) a1=0;
      else a1=(x[p2]-x[p1])/(y[p1]-y[p2]);
      x2=(x[p3]+x[p2])/2;
      y2=(y[p3]+y[p2])/2;
      if (y[p3]==y[p2]) a2=1000000;
      else if (x[p3]==x[p2]) a2=0;
      else a2=(x[p2]-x[p3])/(y[p3]-y[p2]);
      if (a1==1000000) {
        ansx=x1;
        ansy=y2+(x1-x2)*a2;
      } else if (a2==1000000) {
        ansx=x2;
        ansy=y1+(x2-x1)*a1;
      } else {
        t2=y1-a1*x1;
        t4=y2-a2*x2;
        ansx=(t4-t2)/(a1-a2);
        ansy=a1*ansx+t2;
      }
      ans=sqrt((x[p1]-ansx)*(x[p1]-ansx)+(y[p1]-ansy)*(y[p1]-ansy));
      break;
    }
  } else {
    anstype=0;
    ans=sqrt((x[p1]-x[p2])*(x[p1]-x[p2])+(y[p1]-y[p2])*(y[p1]-y[p2]))/2;
    ansx=(x[p1]+x[p2])/2;
    ansy=(y[p1]+y[p2])/2;
    break;
  }
}

fn=fopen("ZAD4.RES", "w");
fprintf(fn, "%.2lf\n%.2lf %.2lf\n", ans, ansx, ansy);
fclose(fn);

return 0;
}
