#include <stdio.h>
#include <math.h>

typedef struct {
double ang;
int vert;
int vis;
} sys;

FILE *fn;
int n, k;
int neis[1024];
sys *nei[1024];
short wsys[1024][1024];
int x[1024];
int y[1024];
int met[1024];
int mcnt;

/*int orient(int a, int b, int c) {
  return x[a]*y[b]+x[b]*y[c]+x[c]*y[a]-x[a]*y[c]-x[b]*y[a]-x[c]*y[b];
}*/

void build(int a, int b, int wr) {
  int oc, c=a, d=b, ik=0;

  memset(met, 0, 4096);
  while (1) {
    oc=c;
    c=nei[c][d].vert;
    d=wsys[c][oc]+1;
    if (d==neis[c]) d=0;
    if (met[c]) wr=0;
    else met[c]=1;
    nei[c][d].vis=1;
    ik++;
    if (c==a && d==b) break;
  }
  if (wr && ik==k) mcnt++;
}

int cmp(sys *a, sys *b) {
  if (a->ang<b->ang) return -1;
  else if (a->ang>b->ang) return 1;
  else return 0;
}

int main(void) {
int i, j, fav1;

fn=fopen("ZAD6.DAT", "r");
fscanf(fn, "%d", &n);
for (i=1; i<=n; i++) {
  fscanf(fn, "%d %d %d", &x[i], &y[i], &neis[i]);
  nei[i]=(sys *)malloc((neis[i]+3)*sizeof(sys));
  for (j=0; j<neis[i]; j++) fscanf(fn, "%d", &nei[i][j].vert);
}
fscanf(fn, "%d", &k);
fclose(fn);

for (i=1; i<=n; i++) {
  for (j=0; j<neis[i]; j++) {
    nei[i][j].ang=atan2(y[nei[i][j].vert]-y[i], x[nei[i][j].vert]-x[i]);
    nei[i][j].vis=0;
  }
  qsort(nei[i], neis[i], sizeof(sys), cmp);
  for (j=0; j<neis[i]; j++) wsys[i][nei[i][j].vert]=j;
  nei[i][neis[i]]=nei[i][0];
}

fav1=1;
for (i=2; i<=n; i++) if (x[i]<x[fav1] || (x[i]==x[fav1] && y[i]<y[fav1])) fav1=i;
build(fav1, 0, 0);
for (i=1; i<=n; i++) {
  for (j=0; j<neis[i]; j++) if (!nei[i][j].vis) build(i, j, 1);
}

fn=fopen("ZAD6.RES", "w");
fprintf(fn, "%d\n", mcnt);
fclose(fn);

return 0;
}
