#include <stdio.h>
#include <math.h>

int n;
double xp[1024*128],yp[1024*128];

double cx,cy,sx,sy;

void findc0(void)
{
  double mxx,mxy,mnx,mny;
  int i;

  mnx = 1e+6;  mny=1e+6;
  mxx = -1e+6; mxy=-1e+6;
  for (i=0;i<n;i++)
  {
    if (xp[i]<mnx) { mnx=xp[i]; }
    if (xp[i]>mxx) { mxx=xp[i]; }
    
    if (yp[i]<mny) { mny=yp[i]; }
    if (yp[i]>mxy) { mxy=yp[i]; }
  }

  cx=(mxx+mnx)*0.5;
  cy=(mxy+mny)*0.5;
  sx=mxx-cx; // Steps
  sy=mxy-cy;
  return;
}

double rfrom(double x1,double y1)
{
  int i;
  double rad,rad1;

  rad=0;
  for (i=0;i<n;i++)
  {
    rad1 = ( (x1-xp[i])*(x1-xp[i]) + (y1-yp[i])*(y1-yp[i]) );
    
    if (rad1>rad) { rad=rad1; }
  }
  return sqrt(rad) + 1e-4;
}

void findc1(void)
{
  int i;
  
  cx=0; cy=0;
  for (i=0;i<n;i++)
  {
    cx+=xp[i];
    cy+=yp[i];
  }
  cx/=n; cy/=n;
}

void optim0(void)
{
  double sx1,sy1,trad,t1;
  sx1=sx;
  sy1=sy;

  trad = rfrom(cx,cy);

  while (sx1>1e-3)
  {
    t1 = rfrom(cx-sx1,cy);
    if (t1<trad) { cx-=sx1; trad = t1; } else
    {
      t1 = rfrom(cx+sx1,cy);
      if (t1<trad) { cx+=sx1; trad = t1; }
    }

    sx1*=0.5;
  }

  while (sy1>1e-3)
  {
    t1 = rfrom(cx,cy-sy1);
    if (t1<trad) { cy-=sy1; trad = t1; } else
    {
      t1 = rfrom(cx,cy+sy1);
      if (t1<trad) { cy+=sy1; trad = t1; }
    }

    sy1*=0.5;
  }
  
}

int main(void)
{
  FILE* f;
  int i;
  double tmp,otg,cx1,cy1,ox,oy;
  f = fopen("zad4.dat","rt");
  fscanf(f,"%d ",&n);
  for (i=0;i<n;i++)
  {
    fscanf(f,"%lf %lf ",&xp[i],&yp[i]);
  }
  fclose(f);

  findc0();
  optim0();
  optim0();
  otg = rfrom(cx,cy); ox=cx; oy=cy;
  cx1=cx; cy1=cy;
  findc1();
  optim0();
  optim0();
  tmp = rfrom(cx,cy);
  if (tmp<otg) { otg=tmp; ox=cx; oy=cy; }
  cx = (cx+cx1)*0.5;
  cy = (cy+cy1)*0.5;
  optim0();
  tmp = rfrom(cx,cy);
  if (tmp<otg) { otg=tmp; ox=cx; oy=cy; }

  f = fopen("zad4.res","wt");
  fprintf(f,"%.2lf\n",otg);
  fprintf(f,"%.2lf %.2lf\n",ox,oy);
  fclose(f);
  
  return 0;
}
